module ModelSimTest(clk, reset, sigma, rho, beta, n, x1, x2, x3);

input clk;
input reset;

input logic signed [26:0] sigma;
input logic signed [26:0] rho;
input logic signed [26:0] beta;
input logic [3:0] n;

output logic signed [26:0] x1;
output logic signed [26:0] x2;
output logic signed [26:0] x3;


// X1 Calculation Logic
logic signed [26:0] funcX1;
signed_mult mul1(funcX1, x2 - x1, (sigma >>> n));
integrator integX1(x1, funcX1, 27'b111111100000000000000000000, clk, reset); // -1

// X2 Calculation Logic
logic signed [26:0] tempX2, funcX2;
signed_mult mul2(tempX2, (x1 >>> n), rho - x3);
assign funcX2 = tempX2 - (x2 >>> n);
integrator integX2(x2, funcX2, 27'b011001100110011001, clk, reset); // 0.1

// X3 Calculation Logic
logic signed [26:0] tempX3_1, tempX3_2, funcX3;
signed_mult mul3(tempX3_1, (x1 >>> n), x2);
signed_mult mul4(tempX3_2, (x3 >>> n), beta);
assign funcX3 = tempX3_1 - tempX3_2;
integrator integX3(x3, funcX3, 27'd25 << 20, clk, reset); // 25


endmodule