localparam RINGBUF_WORD_SIZE   = 32;
localparam RINGBUF_NUM_ENTRIES = 256;
localparam RINGBUF_ADDR_SIZE   = $clog(RINGBUF_NUM_ENTRIES);

module dual_clock_ram (q, d, wr_addr, rd_addr, we, clk1, clk2);

	input  logic [`WORD_SIZE-1:0] d;
	input  logic [`ADDR_SIZE-1:0] wr_addr, rd_addr;
	input  logic                  we, clk1, clk2;

	output logic [`WORD_SIZE-1:0] q;

	logic [`ADDR_SIZE-1:0] read_address_reg;
	logic [`WORD_SIZE-1:0] mem [`NUM_ENTRIES-1:0];

	always @(posedge clk1) begin
		if (we) 
			mem[wr_addr]  <= d;
	end

	always @(posedge clk2) begin
		q 					  <= mem[read_address_reg];
		read_address_reg <= rd_addr;
	end


endmodule