`include "config.sv"

// =================================================
// dual_port_ram
// =================================================

module dual_port_ram (q, d, wr_addr, rd_addr, we, clk1, clk2);

	input  logic [DPR_WORD_SIZE-1:0] d;
	input  logic [DPR_ADDR_SIZE-1:0] wr_addr, rd_addr;
	input  logic                         we, clk1, clk2;

	output logic [DPR_WORD_SIZE-1:0] q;

	logic [DPR_ADDR_SIZE-1:0] read_address_reg;
	logic [DPR_WORD_SIZE-1:0] mem [DPR_NUM_ENTRIES-1:0];

	always @(posedge clk1) begin
		if (we) 
			mem[wr_addr]  <= d;
	end

	always @(posedge clk2) begin
		q 					  <= mem[read_address_reg];
		read_address_reg <= rd_addr;
	end


endmodule