localparam prescalar_size = 20;
localparam address_size = 15;

module function_generator(clk, reset, prescalar_max, current_addr_idx);

input clk, reset;

input  logic [prescalar_size-1:0] prescalar_max;
output logic [address_size-1:0]   current_addr_idx;

logic [prescalar_size-1:0] prescalar;

// Update current_addr_idx according to prescalar 
always @(posedge clk) begin
	if (reset) begin
		current_addr_idx <= 0;
		prescalar        <= 1;
	end else begin
		if (prescalar == prescalar_max) begin
			prescalar        <= 0;
			current_addr_idx <= current_addr_idx + 1;
		end else begin
			prescalar <= prescalar + 1;
		end
	end
end


endmodule